<template>
  <div class="exercises">
    <div class="exercises-title">
      Саҳифаи <b> супоришҳо барои такмили ихтисос</b>
    </div>
    <nuxt-link
      to="/profile/exercises/create"
      class="curve-btn exercises-create"
      type="button"
    >
      <div>Омода намудани супориш</div>
    </nuxt-link>

    <accordion v-if="exercises_list_have_access.length > 0" :key="forceUpdate">
      <template v-slot:title>
        <div class="exercises-desc">
          Рӯйхати супоришҳое, ки аз ҷониби маъмур (администратор) иҷозат дода
          шудаанд:
        </div>
      </template>
      <template v-slot:content>
        <div class="exercises-wrapper">
          <Exercise
            v-for="exercise in exercises_list_have_access"
            :item="exercise"
            :key="exercise._id"
            :access="exercise.access"
          >
            <template v-slot:settings>
              <div class="exercises-settings">
                <button
                  class="exercises-settings__applications"
                  type="button"
                  @click.prevent="openApplications(exercise)"
                  v-if="applications(exercise)"
                >
                  Дархостҳо
                  <span>
                    {{
                      exercise.applications.filter((el) => el.access !== true)
                        .length
                    }}
                  </span>
                </button>
                <button
                  @click.prevent="openMembers(exercise)"
                  class="exercises-settings__applications"
                  type="button"
                  v-if="members(exercise)"
                >
                  Иштирокчиён
                  <span v-if="assignments_count(exercise) > 0">
                    {{ assignments_count(exercise) }}
                  </span>
                </button>
                <button type="button" @click.prevent="removeExercise(exercise)">
                  Тоза кардан
                </button>
              </div>
            </template>
          </Exercise>
        </div>
      </template>
    </accordion>

    <accordion v-if="exercises_list_no_access.length > 0">
      <template v-slot:title>
        <div class="exercises-desc">
          Рӯйхати супоришҳое, ки аз ҷониби маъмур (администратор) баррасӣ карда
          мешаванд:
        </div>
      </template>
      <template v-slot:content>
        <div class="exercises-wrapper">
          <Exercise
          v-for="exercise in exercises_list_no_access"
          :item="exercise"
          :key="exercise._id"
          :access="exercise.access"
          >
          <template v-slot:settings>
            <div class="exercises-settings">
              <!-- <button type="button" class="">Изменить</button> -->
              <div></div>
              <button type="button" @click.prevent="removeExercise(exercise)">
                  Тоза кардан
                </button>
              </div>
            </template>
          </Exercise>
        </div>
      </template>
    </accordion>

    <Modal
      class="applications"
      :value="applicationsModal"
      v-if="applicationsModal"
      @close="closeApplications()"
    >
      <div v-if="applicationsModal" class="applications-wrapper">
        <div class="applications-title">
          <div>Дархостҳо аз ҷониби табибон</div>
          <span>
            Барои супориш: <br />
            {{ exercise.title }}
          </span>
        </div>
        <div class="applications-wrapper">
          <accordion
            v-for="item in exercise.applications.filter(
              (el) => el.access !== true
            )"
            :key="item._id"
          >
            <template v-slot:title>
              <span>{{ item.name }}</span>
            </template>
            <template v-slot:content>
              <ul>
                <li>
                  Телефон: <b>{{ item.phone }}</b>
                </li>
                <li>
                  Вилоят: <b>{{ item.region }}</b>
                </li>
                <li>
                  Ихтисос: <b>{{ item.specialization }}</b>
                </li>
                <li>
                  Чои кор: <b>{{ item.workplace }}</b>
                </li>
              </ul>
              <button @click.stop="giveAccessUser(item.name, item.id)">
                Иҷозат додан
              </button>
            </template>
          </accordion>
        </div>
      </div>
    </Modal>

    <Modal
      class="applications"
      :value="membersModal"
      v-if="membersModal"
      @close="membersModal = false"
    >
      <div v-if="membersModal" class="applications-wrapper">
        <div class="applications-title">
          <div>Иштирокчиён</div>
          <span>
            Барои супориш: <br />
            {{ exercise.title }}
          </span>
        </div>
        <div class="applications-wrapper">
          <accordion
            v-for="item in exercise.applications.filter(
              (el) => el.access !== false
            )"
            :key="item._id"
          >
            <template v-slot:title>
              <span>
                {{ item.name }}
                <b>
                  {{
                    item.assignment
                      ? item.assignment.completed == "pending"
                        ? "( санҷиш талаб карда мешавад   )"
                        : ""
                      : ""
                  }}
                </b>
                <label>
                  {{
                    item.assignment
                      ? item.assignment.completed == "done"
                        ? "( кор ба анҷом расид )  "
                        : ""
                      : ""
                  }}
                </label>
              </span>
            </template>
            <template v-slot:content>
              <ul>
                <li>
                  Телефон: <b>{{ item.phone }}</b>
                </li>
                <li>
                  Вилоят: <b>{{ item.region }}</b>
                </li>
                <li>
                  Ихтисос: <b>{{ item.specialization }}</b>
                </li>
                <li>
                  Чои кор: <b>{{ item.workplace }}</b>
                </li>
                <template v-if="item.assignment">
                  <li>
                    Холҳо: <b>{{ item.assignment.grade }}</b>
                  </li>

                  <li v-if="item.assignment.message">
                    Фаъолияти бекор кардашуда, шарҳи шумо:
                    <b>{{ item.assignment.message }}</b>
                  </li>
                  <template v-if="item.assignment.completed == 'pending'">
                    <button
                      style="margin-right: 20px"
                      type="button"
                      @click="acceptWork(item.id, item.assignment._id)"
                    >
                      Қабул намудани кор
                    </button>
                    <button
                      type="button"
                      @click="cancelWork(item.id, item.assignment)"
                    >
                      Бекор кардан ва дубора ирсол намудан
                    </button>
                  </template>
                </template>
              </ul>
            </template>
          </accordion>
        </div>
      </div>
    </Modal>
    <Confirm />
  </div>
</template>

<script>
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      exercises_list_have_access: [],
      exercises_list_no_access: [],
      applicationsModal: false,
      membersModal: false,
      exercise: null,
      forceUpdate: 1,
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getExercises();
  },
  computed: {
    applications() {
      return (value) => {
        let show = false;
        value.applications
          .filter((el) => el.access !== true)
          .forEach((element) => {
            if (element.access == false) {
              show = true;
            }
          });
        return show;
      };
    },
    members() {
      return (value) => {
        let show = false;
        value.applications
          .filter((el) => el.access !== false)
          .forEach((element) => {
            if (element.access == true) {
              show = true;
            }
          });
        return show;
      };
    },
    assignments_count() {
      return (value) => {
        let count = 0;
        value.applications.forEach((element, id) => {
          if (element.assignment) {
            if (element.assignment.completed == "pending") {
              count = id + 1;
            }
          }
        });
        return count;
      };
    },
  },
  methods: {
    acceptWork(user_id, assignment_id) {
      this.$confirm({
        title: "Предупреждение!",
        message: `Шумо мутмаин ҳастед, ки кори иштирокчиро қабул ва ба итмом расонед?`,
        button: {
          yes: "Да",
          no: "Назад",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/assignments/accept", {
                assignment_id,
              })
              .then(() => {
                this.exercise.applications.forEach((el) => {
                  if (el.id == user_id) {
                    el.assignment.completed = "done";
                  }
                });
                this.forceUpdate += 1;
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    cancelWork(id, assignment) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Шумо мутмаин ҳастед, ки мехоҳед бекор кунед ва дубора ирсол намоед?`,
        button: {
          yes: "Бале",
          no: "Баргаштан",
        },
        callback: (confirm) => {
          if (confirm) {
            const message = prompt("Сабаби бекоркуниро муайян кунед");
            this.$axios
              .$post("/assignments/cancel", {
                message,
                assignment_id: assignment._id,
              })
              .then(() => {
                const url = this.$config.UPLOADS_BACKEND_URL + "/removeReports";
                const remove_list = [];
                if (assignment.reports.length > 0) {
                  assignment.reports.forEach((el) =>
                    remove_list.push("./static" + el)
                  );
                }
                this.$axios
                  .$post(url, { remove_list })
                  .then((response) => {
                    this.exercise.applications.forEach((el) => {
                      if (el.id == id) {
                        el.assignment.canceled = true;
                        el.assignment.reports = [];
                        el.assignment.completed = "waiting";
                      }
                    });
                    this.forceUpdate += 1;
                  })
                  .catch((error) => {
                    console.log(error);
                  });
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    removeExercise(exercise) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Шумо мутмаин ҳастед, ки мехоҳед "${exercise.title}" -ро нест кунед? ?`,
        button: {
          yes: "Тоза кардан",
          no: "Ба қафо",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/exercise/removeExercise", {
                exercise_id: exercise._id,
              })
              .then(() => {
                const url =
                  this.$config.UPLOADS_BACKEND_URL + "/removeExercise";
                const remove_list = [];
                remove_list.push("./static" + exercise.image);
                if (exercise.materials.length > 0) {
                  exercise.materials.forEach((el) =>
                    remove_list.push("./static" + el)
                  );
                }
                this.$axios
                  .$post(url, { remove_list })
                  .then((response) => {
                    if (exercise.access) {
                      this.exercises_list_have_access =
                        this.exercises_list_have_access.filter(
                          (e) => e._id !== exercise._id
                        );
                    } else {
                      this.exercises_list_no_access =
                        this.exercises_list_no_access.filter(
                          (e) => e._id !== exercise._id
                        );
                    }
                  })
                  .catch((error) => {
                    console.log(error);
                  });
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    giveAccessUser(name, id) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Оё мутмаин ҳастед, ки мехоҳед дастрасиро ба система барои "${name}" иҷозат диҳед?`,
        button: {
          yes: "Разрешить",
          no: "Назад",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/profile/giveAccessUser", {
                user_id: id,
                exercise_id: this.exercise._id,
              })
              .then(() => {
                this.exercise.applications.forEach((t) => {
                  if (t.id == id) {
                    t.access = true;
                  }
                });
                if (
                  this.exercise.applications &&
                  this.exercise.applications.length === 0
                ) {
                  this.applicationsModal = false;
                }
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    getExercises() {
      this.$axios
        .$post("/exercise/getExercises", { teacher_id: this.$auth.user._id })
        .then(({ exercises, assignments }) => {
          this.exercises_list_have_access = exercises.filter(
            (e) => e.access !== false
          );
          this.exercises_list_no_access = exercises.filter(
            (e) => e.access !== true
          );
          if (assignments.length > 0) {
            this.assignments = assignments;
            for (const exercise of this.exercises_list_have_access) {
              for (const assignment of this.assignments) {
                if (assignment.exercise_id === exercise._id) {
                  for (const application of exercise.applications) {
                    if (application.id === assignment.user_id) {
                      application.assignment = assignment;
                    }
                  }
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    openMembers(exercise) {
      this.exercise = exercise;
      this.membersModal = true;
    },

    openApplications(exercise) {
      this.exercise = exercise;
      this.applicationsModal = true;
    },

    closeApplications() {
      this.applicationsModal = false;
    },

    goToExercise(url) {
      this.$router.push(url);
    },
  },
};
</script>

<style lang="scss" scoped>
.exercises {
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  min-height: 70vh;
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    b {
    }
    @include less-than(tablet) {
      font-size: 22px;
    }
  }

  &-create {
    display: block;
    margin: 20px 0;
  }

  &-desc {
    line-height: 1.3;
    font-size: 24px;

    @include less-than(tablet) {
      font-size: 18px;
    }
    b {
      font-family: "Montserrat-Bold";
      font-weight: 900;
    }
  }

  &-wrapper {
    padding: 20px 0;
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-gap: 20px;
    text-align: left;
    align-items: center;
    @include less-than(tablet) {
      grid-template-columns: 1fr;
    }
  }

  &-settings {
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    margin-top: auto;
    padding-top: 20px;

    a,
    button {
      padding: 10px;
      transition: all ease 0.3s;
      background-color: #fff;
      border: 1px solid #ccc;
      &:hover {
        border-color: #0c63e4;
        color: #0c63e4;
      }
    }
  }
  &-settings__applications {
    position: relative;
    span {
      top: -10px;
      right: -10px;
      position: absolute;
      display: flex;
      justify-content: center;
      align-items: center;
      width: 20px;
      height: 20px;
      border-radius: 100%;
      background-color: #0c63e4;
      color: #fff;
      font-size: 10px;
    }
  }
}

.applications {
  color: #000;
  font-size: 16px;

  &-title {
    margin-top: 20px;
    text-align: center;
    line-height: 1;
    font-size: 28px;

    display: flex;
    justify-content: center;
    flex-direction: column;
    align-items: center;
    span {
      margin-top: 10px;
      width: 60%;
      font-size: 16px;

      @include less-than(tablet) {
        width: 100%;
      }
    }
  }
  &-wrapper {
    padding: 10px;
    ul {
      padding: 0;
      margin: 0;
    }
    li {
      list-style: none;
      margin: 0;
      padding: 0;
      padding-bottom: 10px;
      a:hover {
        color: #0c63e4;
      }
    }
    button {
      background: none;
      border: 1px solid #ccc;
      padding: 10px;
      margin-bottom: 20px;
      transition: all ease 0.3s;
      &:hover {
        border-color: #0c63e4;
        color: #0c63e4;
      }
    }
    span {
      b {
        color: #0c63e4;
      }
    }
  }
}
</style>
